# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/00_core.ipynb.

# %% auto 0
__all__ = ['list_models']

# %% ../nbs/00_core.ipynb 2
from datetime import datetime
import inspect
import pandas as pd
from fastcore.script import call_parse

# %% ../nbs/00_core.ipynb 3
def _to_dt(dt:int):
    return datetime.fromtimestamp(dt).strftime('%Y-%m-%d')

@call_parse
def list_models(owned:str='' # Filter by who models are owned by
               ):
    "List OpenAI models you have access to."
    from openai import OpenAI
    client = OpenAI()
    models = list(client.models.list())
    models.sort(key=lambda m: -m.created)
    models = [{'Name': m.id, 'Created Dt': _to_dt(m.created)} for m in models if not owned or owned in m.owned_by]
    df = pd.DataFrame(models)
    stack_depth = len(inspect.stack())
    if stack_depth > 3: return df
    else: return df.to_markdown(index=False)
